﻿class triangle{
	private var pt1:point;
	private var pt2:point;
	private var pt3:point;
	private var triarea:Number = 0;
	
	function triangle(p1:point, p2:point, p3:point){
		pt1 = new point(p1.x, p1.y);
		pt2 = new point(p2.x, p2.y);
		pt3 = new point(p3.x, p3.y);
		//Create vector from p1 to p2
		var v:vector = new vector(p2.x - p1.x, p2.y - p1.y);
		var height:Number = distancePointToLine(p3, v, p1);
		if (height>0){
			//Use half base times height formula
			triarea = 0.5 * v.mag() * height;
		}else{
			//Can't be calculated
			triarea = -1;
		}
	}
	
	function get area():Number{
		return triarea;
	}
	
	function distancePointToLine( pp:point, v:vector, org:point):Number{
		var mag:Number = v.mag();
		var slope:Number;
		var intersection:point;
		var p:point = new point(pp.x - org.x, pp.y - org.y);
	 	var tangent:vector;
		
		slope = (p.x * v.x + p.y * v.y )/(mag * mag);
		
		// closest point does not fall within the line segment 
		if( slope < 0 || slope > 1 ) return -1;   
		
		intersection = new point(org.x + slope * v.x, org.y + slope * v.y);	
		tangent = new vector(pp.x - intersection.x, pp.y - intersection.y);
		
		return tangent.mag();
	}

}